Fix typo openssh-client -> openssh-clients
[csit.git] / bootstrap-vpp-verify-semiweekly.sh
index 27078e1..af56e9f 100644 (file)
@@ -21,42 +21,72 @@ RETURN_STATUS=0
 cat /etc/hostname
 cat /etc/hosts
 
-export DEBIAN_FRONTEND=noninteractive
-sudo apt-get -y update
-sudo apt-get -y install libpython2.7-dev python-virtualenv
-
 PYBOT_ARGS="--noncritical MULTI_THREAD"
 
-ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
+JOB_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
+LOG_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
+JOB_ARCHIVE_DIR="archive"
+LOG_ARCHIVE_DIR="$WORKSPACE/archives"
+mkdir -p ${JOB_ARCHIVE_DIR}
+mkdir -p ${LOG_ARCHIVE_DIR}
 
 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
 export PYTHONPATH=${SCRIPT_DIR}
 
+# Create tmp dir
+mkdir ${SCRIPT_DIR}/tmp
+
+# Use tmp dir to store log files
+LOG_PATH="${SCRIPT_DIR}/tmp"
+
+OS_ID=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
+OS_VERSION_ID=$(grep '^VERSION_ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
+
+if [ "$OS_ID" == "centos" ]; then
+    DISTRO="CENTOS"
+    PACKAGE="rpm"
+    sudo yum install -y python-devel python-virtualenv openssh-clients sshpass
+elif [ "$OS_ID" == "ubuntu" ]; then
+    DISTRO="UBUNTU"
+    PACKAGE="deb"
+    export DEBIAN_FRONTEND=noninteractive
+    sudo apt-get -y update
+    sudo apt-get -y install libpython2.7-dev python-virtualenv
+else
+    echo "$OS_ID is not yet supported."
+    exit 1
+fi
 
 # 1st step: Download and prepare VPP packages
 
 # Temporarily download VPP packages from nexus.fd.io
-rm -f *.deb
 if [ "${#}" -ne "0" ]; then
     arr=(${@})
     echo ${arr[0]}
 else
-    # Download the latest VPP build .deb install packages
-    echo Downloading VPP packages...
-    bash ${SCRIPT_DIR}/resources/tools/download_install_vpp_pkgs.sh --skip-install
+    # Download the latest VPP build install packages
+    CSIT_DIR=${SCRIPT_DIR}
+    source "${SCRIPT_DIR}/resources/libraries/bash/function/artifacts.sh"
+    download_artifacts
+    # Need to revert -euo as the rest of script is not optimized for this.
+    set +euo pipefail
 fi
 
-VPP_DEBS=(*.deb)
-echo ${VPP_DEBS[@]}
+VIRL_DIR_LOC="/tmp/"
+VPP_PKGS=(*vpp*.$PACKAGE)
+VPP_PKGS_FULL=("${VPP_PKGS[@]/#/${VIRL_DIR_LOC}}")
+echo ${VPP_PKGS[@]}
 
-VPP_VER=$(echo ${VPP_DEBS#vpp-})
-VPP_VER=$(echo ${VPP_VER%.deb})
-echo VPP version to be tested: ${VPP_VER}
+VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_${DISTRO})
+VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_${DISTRO})
+
+VPP_VER="$( expr match $(ls vpp*.${PACKAGE} | head -n 1) 'vpp[-|_]\(.*\)'.${PACKAGE} )"
 
 set +x
-echo "******************************************************************************"
-echo "1st step: Download VPP packages                                       FINISHED"
-echo "******************************************************************************"
+echo "****************************************************************************************************************************************"
+echo "1st step: Download VPP packages                                                                                                 FINISHED"
+echo "VPP version to be tested: ${VPP_VER}"
+echo "****************************************************************************************************************************************"
 set -x
 
 
@@ -70,9 +100,9 @@ echo Installing requirements...
 pip install -r ${SCRIPT_DIR}/requirements.txt
 
 set +x
-echo "******************************************************************************"
-echo "2nd step: Start virtual env and install requirements                  FINISHED"
-echo "******************************************************************************"
+echo "****************************************************************************************************************************************"
+echo "2nd step: Start virtual env and install requirements                                                                            FINISHED"
+echo "****************************************************************************************************************************************"
 set -x
 
 
@@ -86,6 +116,7 @@ VIRL_USERNAME=jenkins-in
 VIRL_PKEY=priv_key
 VIRL_SERVER_STATUS_FILE="status"
 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
+VIRL_SESSION_EXPIRY="620"
 
 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
 
@@ -161,20 +192,8 @@ do
     fi
 done
 
-
-VIRL_DIR_LOC="/tmp"
-VPP_DEBS_VIRL=(${VPP_DEBS[@]})
-
-# Prepend directory location at remote host to deb file list
-for index in "${!VPP_DEBS_VIRL[@]}"; do
-    VPP_DEBS_VIRL[${index}]=${VIRL_DIR_LOC}/${VPP_DEBS_VIRL[${index}]}
-done
-
-echo "Updated file names: " ${VPP_DEBS_VIRL[@]}
-
-cat ${VIRL_PKEY}
 # Copy the files to VIRL host
-scp ${SSH_OPTIONS} *.deb \
+scp ${SSH_OPTIONS} ${VPP_PKGS[@]} \
     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
 
 result=$?
@@ -194,9 +213,11 @@ function stop_virl_simulation {
 
 VIRL_SID=$(ssh ${SSH_OPTIONS} \
     ${VIRL_USERNAME}@${VIRL_SERVER} \
-    "start-testcase -c double-ring-nested ${VPP_DEBS_VIRL[@]}")
+    "start-testcase -vv --copy ${VIRL_TOPOLOGY} \
+    --expiry ${VIRL_SESSION_EXPIRY} \
+    --release ${VIRL_RELEASE} ${VPP_PKGS_FULL[@]}")
 retval=$?
-if [ "$?" -ne "0" ]; then
+if [ ${retval} -ne "0" ]; then
     echo "VIRL simulation start failed"
     exit ${retval}
 fi
@@ -218,15 +239,15 @@ scp ${SSH_OPTIONS} \
     topologies/enabled/topology_VIRL.yaml
 
 retval=$?
-if [ "$?" -ne "0" ]; then
+if [ ${retval} -ne "0" ]; then
     echo "Failed to copy topology file from VIRL simulation"
     exit ${retval}
 fi
 
 set +x
-echo "******************************************************************************"
-echo "3rd step: Start the simulation on the VIRL server                     FINISHED"
-echo "******************************************************************************"
+echo "****************************************************************************************************************************************"
+echo "3rd step: Start the simulation on the VIRL server                                                                               FINISHED"
+echo "****************************************************************************************************************************************"
 set -x
 
 
@@ -239,22 +260,26 @@ echo Running functional tests on the VIRL system...
 
 # There are used three iterations of functional tests there
 # to check the stability and reliability of the results.
-for test_set in 1 2 3
+partial_logs=""
+for test_set in 1 2
 do
     echo
     echo Functional test loop: ${test_set}
     echo
 
-    pybot -L TRACE \
+    pybot -L TRACE -W 136\
         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
-        --suite "tests.func" \
+        --suite "tests.vpp.func" \
         --include vm_envAND3_node_single_link_topo \
         --include vm_envAND3_node_double_link_topo \
         --exclude PERFTEST \
+        --exclude SOFTWIRE \
+        --exclude SKIP_TEST \
         --noncritical EXPECTED_FAILING \
-        --output log_func_test_set${test_set} \
+        --output ${LOG_PATH}/output_func_test_set${test_set} \
         tests/
     PARTIAL_RC=$(echo $?)
+    partial_logs="${partial_logs} ${LOG_PATH}/output_func_test_set${test_set}.xml"
     if [ ${PARTIAL_RC} -eq 250 ]; then
         MORE_FAILS=1
     fi
@@ -262,9 +287,9 @@ do
 done
 
 set +x
-echo "******************************************************************************"
-echo "4th step: Run functional tests                                        FINISHED"
-echo "******************************************************************************"
+echo "****************************************************************************************************************************************"
+echo "4th step: Run functional tests                                                                                                  FINISHED"
+echo "****************************************************************************************************************************************"
 set -x
 
 # Set RETURN_STATUS=1 if some critical test failed
@@ -276,10 +301,10 @@ fi
 if [ ${RC} -eq 0 ]; then
     set +x
     echo
-    echo "=============================================================================="
-    echo "Final result of all test loops:                                       | PASS |"
+    echo "========================================================================================================================================"
+    echo "Final result of all test loops:                                                                                                 | PASS |"
     echo "All critical tests have passed."
-    echo "=============================================================================="
+    echo "========================================================================================================================================"
     echo
     set -x
 elif [ ${MORE_FAILS} -eq 0 ]; then
@@ -290,19 +315,19 @@ elif [ ${MORE_FAILS} -eq 0 ]; then
     fi
     set +x
     echo
-    echo "=============================================================================="
-    echo "Final result of all test loops:                                       | FAIL |"
+    echo "========================================================================================================================================"
+    echo "Final result of all test loops:                                                                                                 | FAIL |"
     echo "${RC} critical ${HLP_STR} failed."
-    echo "=============================================================================="
+    echo "========================================================================================================================================"
     echo
     set -x
 else
     set +x
     echo
-    echo "=============================================================================="
-    echo "Final result of all test loops:                                       | FAIL |"
+    echo "========================================================================================================================================"
+    echo "Final result of all test loops:                                                                                                 | FAIL |"
     echo "More then 250 critical tests have failed in one test loop."
-    echo "=============================================================================="
+    echo "========================================================================================================================================"
     echo
     set -x
 fi
@@ -312,16 +337,18 @@ echo Post-processing test data...
 
 # Rebot output post-processing
 rebot --noncritical EXPECTED_FAILING \
-      --output output.xml \
-      ./log_func_test_set1.xml ./log_func_test_set2.xml ./log_func_test_set3.xml
+      --output output.xml ${partial_logs}
 
 # Remove unnecessary files
-rm -f ./log_test_set1.xml ./log_test_set2.xml ./log_test_set3.xml
+rm -f ${partial_logs}
 
-# Archive artifacts
-mkdir archive
-for i in ${ARCHIVE_ARTIFACTS[@]}; do
-    cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
+# Archive JOB artifacts in jenkins
+for i in ${JOB_ARCHIVE_ARTIFACTS[@]}; do
+    cp $( readlink -f ${i} | tr '\n' ' ' ) ${JOB_ARCHIVE_DIR}/
+done
+# Archive JOB artifacts to logs.fd.io
+for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
+    cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVE_DIR}/
 done
 
 echo Post-processing finished.

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.